[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Diff for /openbsd/fw_update/fw_install.sh between version 1.74 and 1.85

version 1.74, 2021/12/11 20:57:51 version 1.85, 2021/12/18 22:03:43
Line 16 
Line 16 
 # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.  # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   
 set -o errexit -o pipefail -o nounset  set -o errexit -o pipefail -o nounset
   set +o monitor
   export PATH=/usr/bin:/bin:/usr/sbin:/sbin
   
 CFILE=SHA256.sig  CFILE=SHA256.sig
 DESTDIR=${DESTDIR:-}  DESTDIR=${DESTDIR:-}
Line 38 
Line 40 
         local _i=1 _dir          local _i=1 _dir
   
         # If we're not in the installer,          # If we're not in the installer,
         # we have mktemp and a more hostile environment          # we have mktemp and a more hostile environment.
         if [ -x /usr/bin/mktemp ]; then          if [ -x /usr/bin/mktemp ]; then
                 _dir=$( mktemp -d "${1}-XXXXXXXXX" )                  _dir=$( mktemp -d "${1}-XXXXXXXXX" )
         else          else
Line 51 
Line 53 
 }  }
   
 fetch() {  fetch() {
         local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _exit          local _src="${FWURL}/${1##*/}" _dst=$1 _user=_file _pid _exit
   
         # If we're not in the installer, we have su(1)          # If we're not in the installer,
         # and doas(1) is unlikely to be configured.          # we have su(1) and doas(1) is unlikely to be configured.
           set -o monitor # make sure ftp gets its own process group
           (
         if [ -x /usr/bin/su ]; then          if [ -x /usr/bin/su ]; then
                 /usr/bin/su -s /bin/ksh "$_user" -c \                  exec /usr/bin/su -s /bin/ksh "$_user" -c \
                     "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"                      "/usr/bin/ftp -D 'Get/Verify' -Vm -o- '$_src'" > "$_dst"
                 _exit="$?"  
         else          else
                 /usr/bin/doas -u "$_user" \                  exec /usr/bin/doas -u "$_user" \
                     /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"                      /usr/bin/ftp -D 'Get/Verify' -Vm -o- "$_src" > "$_dst"
                 _exit="$?"  
         fi          fi
           ) & _pid=$!
           set +o monitor
   
           trap "kill -TERM '-$_pid'; exit 1" EXIT INT QUIT ABRT TERM
   
           SECONDS=0
           _last=0
           while kill -0 -"$_pid" 2>/dev/null; do
                   if [[ $SECONDS -gt 12 ]]; then
                           set -- $( ls -ln "$_dst" 2>/dev/null )
                           if [[ $_last -ne $5 ]]; then
                                   _last=$5
                                   SECONDS=0
                                   sleep 1
                           else
                                   kill -INT -"$_pid"
                                   echo "fetch timed out" >&2
                           fi
                   else
                           sleep 1
                   fi
           done
   
           set +o errexit
           wait "$_pid"
           _exit=$?
           set -o errexit
   
           trap "" EXIT INT QUIT ABRT TERM
   
         if [ "$_exit" -ne 0 ]; then          if [ "$_exit" -ne 0 ]; then
                 rm -f "$_dst"                  rm -f "$_dst"
                 echo "Cannot fetch $_src" >&2                  echo "Cannot fetch $_src" >&2
Line 81 
Line 112 
 }  }
   
 devices_needing_firmware() {  devices_needing_firmware() {
         local _d _m _grep _dmesgtail _last=''          local _d _m _line _dmesgtail _last=''
   
         # When we're not in the installer, the dmesg.boot can          # When we're not in the installer, the dmesg.boot can
         # contain multiple boots, so only look in the last one          # contain multiple boots, so only look in the last one
         _dmesgtail=$( sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot )          sed -n 'H;/^OpenBSD/h;${g;p;}' /var/run/dmesg.boot |
               grep -e "^[a-z][a-z]*[0-9]" -e " not configured " | { \
                   _m=0
                   set -A _dmesgtail
                   while read -r _line; do
                           _dmesgtail[$_m]="$_line"
                           let _m=$_m+1
                   done
   
         grep -v '^[[:space:]]*#' "$FWPATTERNS" |                  grep -v '^[[:space:]]*#' "$FWPATTERNS" |
             while read -r _d _m; do                      while read -r _d _m; do
                 _grep="grep"                          [ "$_d" = "$_last" ] && continue
                 [ "$_last" = "$_d" ] && continue                          [ "$_m" ] || _m="^${_d}[0-9] at "
                 [ "$_m" ] || _m="^${_d}[0-9][0-9]* at "  
                 [ "$_m" = "${_m#^}" ] && _grep="fgrep"  
   
                 echo "$_dmesgtail" | $_grep -q "$_m" || continue                          if [ "$_m" = "${_m#^}" ]; then
                 echo "$_d"                                  _m="*$_m"
                 _last="$_d"                          else
         done                                  _m="${_m#^}"
                           fi
   
                           for _line in "${_dmesgtail[@]}"; do
                                   if [[ $_line = ${_m}* ]]; then
                                           echo "$_d"
                                           _last="$_d"
                                   fi
                           done
                       done
           }
 }  }
   
 firmware_filename() {  firmware_filename() {
Line 173 
Line 219 
 }  }
   
 usage() {  usage() {
         echo "usage: fw_install [-d dir | -L dir] [driver | file [...]]"          echo "usage: fw_install [-DL] [driver | file [...]]"
         exit 2          exit 2
 }  }
   
 INSTALL=true  INSTALL=true
 DOWNLOAD=true  DOWNLOAD=true
   
 while getopts dL name  while getopts DL name
 do  do
        case "$name" in         case "$name" in
        # "download only" means local dir and don't install         # "download only" means local dir and don't install
        d) LOCALSRC=. INSTALL=false ;;         D) LOCALSRC=. INSTALL=false ;;
        L) LOCALSRC=. ;;         L) LOCALSRC=. ;;
        ?) usage 2 ;;         ?) usage 2 ;;
        esac         esac
Line 196 
Line 242 
 [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false  [ "$LOCALSRC" ] && "$INSTALL" && DOWNLOAD=false
 [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"  [ "$LOCALSRC" ] || LOCALSRC="$( tmpdir "${DESTDIR}/tmp/fw_install" )"
   
   CFILE="$LOCALSRC/$CFILE"
   
 set -A devices -- "$@"  set -A devices -- "$@"
   
 [ "${devices[*]:-}" ] ||  [ "${devices[*]:-}" ] ||
Line 219 
Line 267 
                 f=$( firmware_filename "$d" || true )                  f=$( firmware_filename "$d" || true )
                 [ "$f" ] || continue                  [ "$f" ] || continue
                 f="$LOCALSRC/$f"                  f="$LOCALSRC/$f"
         elif ! "$INSTALL" && ! grep -q "($f)" "$CFILE" ; then          elif ! "$INSTALL" && ! grep -Fq "($f)" "$CFILE" ; then
                 echo "Cannot download local file $f" >&2                  echo "Cannot download local file $f" >&2
                 exit 2                  exit 2
         fi          fi
Line 241 
Line 289 
                         verify "$f" || continue                          verify "$f" || continue
                 # else assume it was verified when downloaded                  # else assume it was verified when downloaded
                 fi                  fi
         elif "$INSTALL" && ! "$DOWNLOAD"; then          elif "$DOWNLOAD"; then
                 echo "Cannot install ${f##*/}, not found" >&2  
                 continue  
         else  
                 fetch  "$f" || continue                  fetch  "$f" || continue
                 verify "$f" || continue                  verify "$f" || continue
           elif "$INSTALL"; then
                   echo "Cannot install ${f##*/}, not found" >&2
                   continue
         fi          fi
   
         "$INSTALL" || continue          "$INSTALL" || continue

Legend:
Removed from v.1.74  
changed lines
  Added in v.1.85

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>